#include <stdlib.h>
#include <assert.h>
#include <stdio.h>
#include <string.h>
#include "ip-mtbdd.h"

int main(int argc, char **argv)
{
  MTBDD *bdd;
  char countries[256][3], buffer[3];
  int parse_ip[4];
  IPaddress address;
  int country;

  if (argc != 2 ||
       sscanf(argv[1], "%d.%d.%d.%d",
	  parse_ip, parse_ip+1, parse_ip+2, parse_ip+3) != 4)
  {
    fprintf(stderr, "Usage: %s aa.bb.cc.dd\n", argv[0]);
    exit(1);
  }

  address= (((IPaddress) parse_ip[0]) << 24) +
           (((IPaddress) parse_ip[1]) << 16) +
           (((IPaddress) parse_ip[2]) << 8) +
           ((IPaddress) parse_ip[3]);
 
  {
    int i;
    for(i=0; i<256; i++) countries[i][0]=0;
  }

  {
    FILE *fp;
    int code;
    fp = fopen("countries.dat", "ra");
    if (fp == NULL)
    {
      fprintf(stderr, "Cannot open countries.dat\n");
      exit(1);
    }
    while (!feof(fp))
    {
      fscanf(fp, "%2s: %d\n", buffer, &code);
      strcpy(countries[code], buffer);
    }
    fclose(fp);
  }

  bdd=mtbdd_read("internet.ipmap");
  if (bdd == NULL)
  {
    fprintf(stderr, "Could not read IP-map.\n");
    exit(1);
  }
  country=mtbdd_find(bdd, address, 32);
  printf("country=%s\n", country>=0 ? countries[country] : "??");
  return 0;
}
